#if !defined(AFX_UNITSEDITBOX_H__1104A746_D900_11D5_B71D_006067737BDC__INCLUDED_)
#define AFX_UNITSEDITBOX_H__1104A746_D900_11D5_B71D_006067737BDC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UnitsEditBox.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CUnitsEditBox window

static const enum UnitsPrecision {CU_PREC16, CU_PREC8, CU_PREC4, CU_PREC2};

#include <vector>
#include "afxwin.h"

class CUnitsEditBox : public CEdit
{
	DECLARE_DYNCREATE(CUnitsEditBox)
// Construction
public:
	CUnitsEditBox();
	void		SetPrecision(int nPrecision = CU_PREC8);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CUnitsEditBox)
	//}}AFX_VIRTUAL

// Implementation
public:
	void		SelectAll();
	void		SaveValue();
	void		Restore();
	void		SetValue(double dValue);
	void		SetValue(double dValue, BOOL bImperial);
	void		SetWindowText(CString csVale);

	int			GetWindowText(CString& csString);
	double		GetDoubleValue();
	void		SetUnits(BOOL bImperial = TRUE);
	virtual		~CUnitsEditBox();
	BOOL		VerifyFormat();

	void		RealToString(/*in*/double dValue, /*out*/CString& csResult);
	void		StringToReal(const CString& csInVal, double& dRetVal, BOOL bImperial);

	// Generated message map functions
protected:
	//{{AFX_MSG(CUnitsEditBox)
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private: // Functions
	BOOL		ChangeUnits();
	CString		FormatString(CString csString);
	CString		GetFraction(int nIndex);

private: // Variables
	CString		m_csOldValue;
	BOOL		m_bImperial;
	double		m_dCurValue;
	int			m_nPrecision;

	std::vector<double>				m_Range;
	std::vector<double>::iterator	m_Iter;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UNITSEDITBOX_H__1104A746_D900_11D5_B71D_006067737BDC__INCLUDED_)
